Subject: Re: rebasing merges

From: Andreas Ericsson <[email-masked]>
Date: Tue, 23 Sep 2008 11:11:29 +0200

Stephen Haberman wrote:
>>>  ---A--B--C--D           <-- origin/stable
>>>      \       |
>>>       E--F   |           <-- origin/topica
>>>           \  |
>>>              g--h        <-- topica
>>>
>>> All the upper case commits have been published to origin. Other
>>> devs, etc., know about them, their hashes are in the bug tracking
>>> system.
>>>
>>> I'm bringing topica up to date, but with a merge because I have
>>> published history already on topica, so I merge stable and get a
>>> new merge commit: g. And maybe make another change: h.
>>>
>> Why do you merge stable at this point?
> 
> Good question--I appreciate the sanity check.
> 
> I merged stable because we had a new release of the software. E.g.
> A=1.0, B=1.1, C=1.2, and finally D=1.3.
> 
> So, topica is a new feature, "Add widgets/whatever", but it's not ready
> for stable (production) yet, so, yes, I think it is a topic branch.
> 
> However, D=1.4 is now out the door, I've had two commits E and F on
> topica that I had already committed and pushed out for code review, our
> email list, and our bug tracker, and now, post-1.4, qa wants to see
> topica up and running to see if it's good enough to go into the next
> release.
> 
> If our deployment guy pushes out F, qa is going to (and did) complain
> that they're not seeing the latest features from 1.4 in topica.
> 
> As you said, integration testing.
> 
> Okay, so I merge g, however, I really want to push it back out so that
> the deployment guy can push it to qa (he would rather not resolve my
> conflicts by making his own local g). And even if I did the deployment
> myself, locally against g, I would prefer to share g in case another
> dev working on the same topic gets feedback about funkiness from qa and
> would like to see the code as it is in qa. E.g.: g.
> 
> I can appreciate that if I was doing integration testing all by myself,
> with only automated tests, I could throw g away. However, even then, I
> would prefer to push g out and let our integration server run the tests
> for me.
> 
> Does this sound reasonable?
> 

It sounds very reasonable indeed, but then I don't understand why you
held off pushing the merge.

That's beside the point though, as I firmly believe git should be more
helpful in this situation. If "git rebase -i -p" doesn't help you fix
the problems, I'll see what I can do to help.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231